/*
** makedirs.c - part of GrabURL 2.0
** Copyright (C) 1996-97 Serge Emond
**
** This program is free software; you can redistribute it and/or
** modify it under the terms of the GNU General Public License
** as published by the Free Software Foundation; either version 2
** of the License, or (at your option) any later version.
**
** This program is distributed in the hope that it will be useful,
** but WITHOUT ANY WARRANTY; without even the implied warranty of
** MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
** GNU General Public License for more details.
**
** You should have received a copy of the GNU General Public License
** along with this program; if not, write to the Free Software
** Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.
*/

#include <stdlib.h>
#include <unistd.h>
#include <string.h>
#include <sys/types.h>
#include <fcntl.h>
#include <sys/stat.h>

#ifdef __SASC
#include <stdio.h>
#endif

/*
** Create the directories that are needed to create a file named "fname"
*/

int makedirs(char *fname, int umode)
{
	char *p, *p2, tok[256];
	int l;
	p = fname;
	while ((p2 = strchr(p, '/')) != 0) {
	  l = (int)p2 - (int)fname;
	  strncpy(tok, fname, l);
	  tok[l] = 0;
	  if (access(tok, F_OK)) {
		/* attempt to create the directory */
#ifdef __SASC
		if (mkdir(tok)) {
#else
		if (mkdir(tok, umode)) {
#endif
/*		  fprintf("Error creating directory \"%s\"\n", tok);
		  exit(EXIT_FAILURE); */
		  return(1);
		}
	  }
	  p = p2+1;
	}
	return(0);
}

